require "util"
require "defines"

game.oninit(function()
glob.clones = {}
glob.remains = {}
glob.easy_death = {}
glob.easy_death.print = false -- change to always print coords upon death
glob.easy_death.remains = false -- change to always spawn remains

if glob.easy_death.print then
  return 
elseif game.difficulty == defines.difficulty.easy then glob.easy_death.print = true
else glob.easy_death.print = false
end

if glob.easy_death.remains then
  return
elseif game.difficulty == defines.difficulty.easy or game.difficulty == defines.difficulty.normal then glob.easy_death.remains = true
else glob.easy_death.remains = false
end

end) --leads to error 12: attempt to index field 'easy_death' (a nil value)

game.onevent(defines.events.onentitydied, function(event)
  if game.player.character.equals(event.entity) then
    if glob.easy_death.print then game.player.print("X: "..event.entity.position.x.." Y: "..event.entity.position.y) end
    for k,clone in pairs (glob.clones) do
      if clone.valid == false then table.remove(glob.clones, k) end
    end
    if glob.clones[1] then
      game.setgamestate{gamefinished=false, playerwon=false}
      local clone=game.createentity{name="player", position=glob.clones[1].position}
      glob.clones[1].destroy() --test only, will probably replace with remnant
      table.remove(glob.clones,1)
      game.player.character = clone
      
      if glob.easy_death.remains then 
        local remains = game.createentity{name="player-remains", position=event.entity.position} --create player's remains at death location
        glob.remains[#glob.remains+1] = remains
        local inv = {}
        inv[1] = event.entity.getinventory(defines.inventory.playerquickbar).getcontents()
        inv[2] = event.entity.getinventory(defines.inventory.playermain).getcontents()
        inv[3] = event.entity.getinventory(defines.inventory.playerguns).getcontents()
        inv[4] = event.entity.getinventory(defines.inventory.playertools).getcontents()
        inv[5] = event.entity.getinventory(defines.inventory.playerammo).getcontents()
        inv[6] = event.entity.getinventory(defines.inventory.playerarmor).getcontents()
        for _,table in ipairs (inv) do
          for name, count in pairs(table) do
            remains.insert{name=name,count=count}        
          end
        end
      end
    end
  end
end)

game.onevent(defines.events.onbuiltentity, function(event)
  if event.createdentity.name == "cloning-tank" then
    glob.clones[#glob.clones+1] = event.createdentity
  end
end)

game.onevent(defines.events.ontick, function(event)
  if glob.easy_death.remains and (game.tick%600 == 0) then
    for k,remains in pairs (glob.remains) do
      if remains.getinventory(defines.inventory.chest).getitemcount() == 0 then
        remains.die()
        table.remove(glob.remains, k)
      end
    end
  end
end)
